## spades 4.0.0+dfsg1

=== src/CMakeLists.txt ===
# -*- cmake -*-
############################################################################
# Copyright (c) 2023-2024 SPAdes team
# Copyright (c) 2015-2022 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

# Hard prerequisites
cmake_minimum_required(VERSION 3.16)

project(SpadesToolkit
        VERSION 3.16.0
        LANGUAGES C CXX)

# allow more human readable "if then else" constructs
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)

# modules to find additional libraries (like zlib, boost and etc)
# Add path for custom modules
set(CMAKE_MODULE_PATH
  ${CMAKE_MODULE_PATH}
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake"
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")
# Add some utility macro
include(utils)

# Define various dirs
set(SPADES_MAIN_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(SPADES_MAIN_PROJ_DIR ${SPADES_MAIN_SRC_DIR}/projects)
set(SPADES_MODULES_DIR ${SPADES_MAIN_SRC_DIR}/common)
set(SPADES_MAIN_INCLUDE_DIR ${SPADES_MAIN_SRC_DIR}/include)
set(SPADES_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
set(SPADES_TOOLS_BINARY_DIR ${SPADES_BINARY_DIR}/bin)
set(SPADES_BUILT_INCLUDE_DIR ${SPADES_BINARY_DIR}/include)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SPADES_TOOLS_BINARY_DIR})
set(EXT_DIR "${CMAKE_SOURCE_DIR}/../ext")

# Uncomment for gprof profiling
#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
#SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pg")
#SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -pg")

# Everything option-dependent
include(options)

# Sanity check our source directory to make sure that we are not trying to
# generate an in-tree build
if ((CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR) OR
    (CMAKE_SOURCE_DIR STREQUAL "${CMAKE_BINARY_DIR}/src"))
  message(FATAL_ERROR "In-source builds are not allowed.
Please create a directory and run cmake from there, passing the path
to this source directory as the last argument.
This process created the file `CMakeCache.txt' and the directory `CMakeFiles'.
Please delete them.")
endif()

# Handle commond deps
include(deps)

# Add flags if necessary
include(flags)

# Handle common includes
include(includes)

# Handle common libs
include(libs)

include(GetGitRevisionDescription)
get_git_head_revision(SPADES_GIT_REFSPEC SPADES_GIT_SHA1)
if ((NOT SPADES_GIT_REFSPEC) OR (SPADES_GIT_REFSPEC STREQUAL "GITDIR-NOTFOUND"))
  set(SPADES_GIT_REFSPEC "N/A")
endif()
if (NOT SPADES_GIT_SHA1)
  set(SPADES_GIT_SHA1 "N/A")
endif()

file(STRINGS "${CMAKE_SOURCE_DIR}/../VERSION" VERSION_STRING LIMIT_COUNT 1)
string(REGEX MATCH "([a-zA-Z]*)-\?([0-9]+)\.([0-9]+)\.([0-9]+)(.*)" ver "${VERSION_STRING}")
if (ver STREQUAL "")
  message(FATAL_ERROR "Error to parse version string from ${VERSION_STRING}")
endif()
if (CMAKE_MATCH_1 STREQUAL "")
  set(SPADES_FLAVOUR "SPAdes")
else()
  set(SPADES_FLAVOUR "${CMAKE_MATCH_1}")
endif()
set(SPADES_VERSION_MAJOR "${CMAKE_MATCH_2}")
set(SPADES_VERSION_MINOR "${CMAKE_MATCH_3}")
set(SPADES_VERSION_PATCH "${CMAKE_MATCH_4}")
set(SPADES_VERSION_SUFFIX "${CMAKE_MATCH_5}")
set(SPADES_PACKAGE_VERSION "${SPADES_VERSION_MAJOR}.${SPADES_VERSION_MINOR}.${SPADES_VERSION_PATCH}${SPADES_VERSION_SUFFIX}")
message(STATUS "Building ${SPADES_FLAVOUR} version ${SPADES_PACKAGE_VERSION}")

# Testing
include(test)

message("Building SPAdes from ${SPADES_GIT_REFSPEC}, sha: ${SPADES_GIT_SHA1}")

configure_file("${SPADES_MAIN_INCLUDE_DIR}/config.hpp.in"
               "${SPADES_BUILT_INCLUDE_DIR}/config.hpp")
configure_file("${SPADES_MAIN_INCLUDE_DIR}/version-gen.hpp.in"
               "${SPADES_BUILT_INCLUDE_DIR}/version-gen.hpp")

# Build external dependencies (if any)
add_subdirectory("${EXT_DIR}/src" "${PROJECT_BINARY_DIR}/ext")
add_subdirectory("${EXT_DIR}/include" "${PROJECT_BINARY_DIR}/ext-include-only")

# Setup warnings
add_compile_options(-Wall -Wextra -Wconversion -Wno-sign-conversion -Wno-long-long -Wwrite-strings)
if (NOT OPENMP_FOUND)
  add_compile_options(-Wno-unknown-pragmas)
endif()

# Looking for README.md
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../README.md")
  #installing from archive
  set(README_MD_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../README.md")
else()
  #installing from the repo
  set(README_MD_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../../README.md")
endif()

# sub projects
include(proj)
add_subdirectory(common)
add_subdirectory(projects)

# FIXME: Should we just configure spades_init instead?
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../VERSION"
        DESTINATION share/spades
        COMPONENT common)
# manual, LICENSE, and GPLv2
install(FILES "${README_MD_PATH}"
        DESTINATION share/spades
        COMPONENT spades-docs)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../LICENSE"
        DESTINATION share/spades
        COMPONENT common)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../GPLv2.txt"
        DESTINATION share/spades
        COMPONENT common)

# Random stuff
include(CMakeListsInternal.txt)

# Packaging
include(pack)

# Workaround for poor CLion users
file(GLOB_RECURSE clion_all_headers
  ${CMAKE_SOURCE_DIR}/*.hpp ${CMAKE_SOURCE_DIR}/*.h)
add_custom_target(all_clion SOURCES ${clion_all_headers})

=== ext/include/CMakeLists.txt ===
# -*- cmake -*-

set(BLAZE_LIBRARY_PATH ${EXT_DIR}/include/blaze)
list(APPEND CMAKE_MODULE_PATH ${BLAZE_LIBRARY_PATH}/cmake)
include(Blaze_Import)

Blaze_Import(
   THREADING C++11
   CACHE_SIZE auto
   VECTORIZATION on
)

=== ext/src/CMakeLists.txt ===
# -*- cmake -*-

include(FetchContent)

if (SPADES_USE_JEMALLOC)
  add_subdirectory(jemalloc EXCLUDE_FROM_ALL)
endif()
if (SPADES_USE_MIMALLOC)
  add_subdirectory(mimalloc EXCLUDE_FROM_ALL)
endif()

# Need to put it first as e.g. bwa depends on zlib
FetchContent_Declare(zlib_ng
  SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/zlib-ng")
FetchContent_GetProperties(zlib_ng)
if (NOT zlib_ng_POPULATED)
  set(SKIP_INSTALL_ALL ON)
  set(ZLIB_COMPAT ON)
  set(WITH_GTEST OFF)
  FetchContent_Populate(zlib_ng)
  add_subdirectory(${zlib_ng_SOURCE_DIR} ${zlib_ng_BINARY_DIR} EXCLUDE_FROM_ALL)
endif()

add_subdirectory(nlopt)
add_subdirectory(python_libs/joblib3)
add_subdirectory(python_libs/pyyaml3)
add_subdirectory(bamtools)
add_subdirectory(samtools)
add_subdirectory(cppformat)
add_subdirectory(ssw)
add_subdirectory(llvm)
add_subdirectory(bwa)
add_subdirectory(gqf)
add_subdirectory(edlib)
add_subdirectory(lexy)
add_subdirectory(easel)
add_subdirectory(hmmer)
add_subdirectory(googletest)
add_subdirectory(teamcity_gtest)
add_subdirectory(spoa)
if (SPADES_USE_NCBISDK)
  add_subdirectory(ncbi EXCLUDE_FROM_ALL)
endif()

=== src/common/CMakeLists.txt ===
############################################################################
# Copyright (c) 2023-2024 SPAdes team
# Copyright (c) 2015-2022 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(common_modules CXX)

add_subdirectory(configs)
add_subdirectory(library)
add_subdirectory(pipeline)
add_subdirectory(sequence)
add_subdirectory(assembly_graph)
add_subdirectory(alignment)
add_subdirectory(modules/path_extend)
add_subdirectory(modules)
add_subdirectory(paired_info)
add_subdirectory(stages)
add_subdirectory(utils)
add_subdirectory(io)
add_subdirectory(kmer_index)
add_subdirectory(modules/coverage_model)
add_subdirectory(hmm)
add_subdirectory(toolchain)

add_library(common_modules
            adt/concurrent_dsu.cpp)

target_link_libraries(common_modules library
                      assembly_graph input pipeline sequence
                      coverage_model paired_info path_extend
                      stages mph_index modules
                      utils configs alignment)

=== src/projects/CMakeLists.txt ===
############################################################################
# Copyright (c) 2023-2024 SPAdes team
# Copyright (c) 2015-2022 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

# This file will recurse into all subdirectories that contain CMakeLists.txt
# Setting variables that match the pattern SPADES_TOOL_{NAME}_BUILD to Off will
# prevent traversing into a directory.
#
# The only tools that need to be explicitly added are ones that have explicit
# ordering requirements.

# Iterates all the subdirectories to create CMake options to enable/disable
# traversing each directory.
create_spades_tool_options()

# Automatically add remaining sub-directories containing a 'CMakeLists.txt'
# file as external projects.
add_spades_implicit_projects()

# Add subprojects specified using SPADES_EXTERNAL_PROJECTS
foreach(p ${SPADES_EXTERNAL_PROJECTS})
  add_spades_external_project(${p})
endforeach(p)

=== ext/include/blaze/CMakeLists.txt ===
#==================================================================================================
#
#   CMake file exposing Blaze configuration and allowing integration in CMake projects.
#
#   Copyright (C) 2012-2020 Klaus Iglberger - All Rights Reserved
#
#   This file is part of the Blaze library. You can redistribute it and/or modify it under
#   the terms of the New (Revised) BSD License. Redistribution and use in source and binary
#   forms, with or without modification, are permitted provided that the following conditions
#   are met:
#
#   1. Redistributions of source code must retain the above copyright notice, this list of
#      conditions and the following disclaimer.
#   2. Redistributions in binary form must reproduce the above copyright notice, this list
#      of conditions and the following disclaimer in the documentation and/or other materials
#      provided with the distribution.
#   3. Neither the names of the Blaze development group nor the names of its contributors
#      may be used to endorse or promote products derived from this software without specific
#      prior written permission.
#
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
#   EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
#   OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
#   SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
#   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
#   TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
#   BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
#   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
#   ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
#   DAMAGE.
#
#==================================================================================================

cmake_minimum_required(VERSION 3.5)

file(READ blaze/system/Version.h BLAZE_VERSION_FILE)

string(REGEX MATCH "#define BLAZE_MAJOR_VERSION ([0-9]*)" _BLAZE_MAJOR_VERSION ${BLAZE_VERSION_FILE})
set(BLAZE_MAJOR_VERSION ${CMAKE_MATCH_1})

string(REGEX MATCH "#define BLAZE_MINOR_VERSION ([0-9]*)" _BLAZE_MINOR_VERSION ${BLAZE_VERSION_FILE})
set(BLAZE_MINOR_VERSION ${CMAKE_MATCH_1})

project(blaze LANGUAGES CXX VERSION "${BLAZE_MAJOR_VERSION}.${BLAZE_MINOR_VERSION}")

message(STATUS "Configuring blaze version ${PROJECT_VERSION}")

add_library(blaze INTERFACE)
target_include_directories(blaze INTERFACE
   $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
   $<INSTALL_INTERFACE:include>
   )

if(${CMAKE_VERSION} VERSION_LESS "3.8.0")
   message(STATUS "Blaze requires compiling in mode supporting C++14 features.")
else()
   target_compile_features(blaze INTERFACE cxx_std_14)
endif()


#==================================================================================================
# Configure LAPACK
#==================================================================================================

# Blaze has a link time dependency on several LAPACK operations (matrix decomposition, matrix
# inversion, eigenvalue computation, ...). However, this check here in combination with making
# the LAPACK package REQUIRED makes sure that packagers don't accidently forget this dependency
# on LAPACK.
option (USE_LAPACK "If enabled, checks for the presence of LAPACK during configuration. Disable if you plan on not using LAPACK operations." ON)

if (USE_LAPACK)
   find_package(LAPACK REQUIRED)
   target_link_libraries(blaze INTERFACE $<BUILD_INTERFACE:${LAPACK_LIBRARIES}>)
   target_compile_options(blaze INTERFACE $<BUILD_INTERFACE:${LAPACK_LINKER_FLAGS}>)
endif()


#==================================================================================================
# Configure cache size
#==================================================================================================

set(BLAZE_CACHE_SIZE_DEFAULT "3072" CACHE INTERNAL "Default value for the cache size in Kilobytes.")
set(BLAZE_CACHE_SIZE_AUTO ON CACHE BOOL "Find automatically the cache size.")

if (${BLAZE_CACHE_SIZE_AUTO})
   set(flag 1)
   if (WIN32)
      execute_process(COMMAND wmic cpu get L3CacheSize
                      OUTPUT_VARIABLE tmp
                      RESULT_VARIABLE flag
                      ERROR_QUIET)
      if (flag)
         execute_process(COMMAND wmic cpu get L2CacheSize
                         OUTPUT_VARIABLE tmp
                         RESULT_VARIABLE flag
                         ERROR_QUIET)
      endif (flag)
      if (flag)
         execute_process(COMMAND wmic cpu get L1CacheSize
                         OUTPUT_VARIABLE tmp
                         RESULT_VARIABLE flag
                         ERROR_QUIET)
      endif (flag)
   endif (WIN32)

   if (UNIX)
      execute_process(COMMAND cat /sys/devices/system/cpu/cpu0/cache/index3/size
                      OUTPUT_VARIABLE tmp
                      RESULT_VARIABLE flag
                      ERROR_QUIET)
      if (flag)
         execute_process(COMMAND cat /sys/devices/system/cpu/cpu0/cache/index2/size
                         OUTPUT_VARIABLE tmp
                         RESULT_VARIABLE flag
                         ERROR_QUIET)
      endif (flag)
      if (flag)
         execute_process(COMMAND cat /sys/devices/system/cpu/cpu0/cache/index1/size
                         OUTPUT_VARIABLE tmp
                         RESULT_VARIABLE flag
                         ERROR_QUIET)
      endif (flag)
   endif (UNIX)

   if (APPLE)
      execute_process(COMMAND sysctl -n hw.l3cachesize
                      OUTPUT_VARIABLE tmp
                      RESULT_VARIABLE flag
                      ERROR_QUIET)
      if (flag)
         execute_process(COMMAND sysctl -n hw.l2cachesize
                         OUTPUT_VARIABLE tmp
                         RESULT_VARIABLE flag
                         ERROR_QUIET)
      endif (flag)
      if (flag)
         execute_process(COMMAND sysctl -n hw.l1icachesize
                         OUTPUT_VARIABLE tmp
                         RESULT_VARIABLE flag
                         ERROR_QUIET)
      endif (flag)

      if (flag EQUAL 0)
         math(EXPR tmp ${tmp}/1024)  # If successful convert to kibibytes to comply with rest
      endif (flag EQUAL 0)
   endif (APPLE)

   if (flag)
      message("Cache size not found automatically. Using default value as cache size.")
      set(tmp ${BLAZE_CACHE_SIZE_DEFAULT})
   endif (flag)

   string(REGEX MATCH "([0-9][0-9]+)" tmp ${tmp}) # Get a number containing at least 2 digits in the string tmp
   math(EXPR BLAZE_CACHE_SIZE ${tmp}*1024) # Convert to bytes (assuming that the value is given in kibibytes)

endif (${BLAZE_CACHE_SIZE_AUTO})

if (NOT ${BLAZE_CACHE_SIZE_AUTO})
   message("Use value set manually as cache size.")
   set(BLAZE_CACHE_SIZE ${BLAZE_CACHE_SIZE})
endif ()

set(BLAZE_CACHE_SIZE ${BLAZE_CACHE_SIZE} CACHE STRING "Cache size of the CPU in bytes." FORCE)

configure_file ("${CMAKE_CURRENT_LIST_DIR}/cmake/CacheSize.h.in"
                "${CMAKE_CURRENT_BINARY_DIR}/blaze/config/CacheSize.h")


#==================================================================================================
# Configure BLAS
#==================================================================================================

set(BLAZE_BLAS_MODE OFF CACHE BOOL "Enables/Disable the BLAS mode.")

if (BLAZE_BLAS_MODE)
   find_package (BLAS REQUIRED)
   set(BLAZE_BLAS_IS_64BIT 0 CACHE BOOL "Specify whether the used BLAS library itself is 64-bit or not.")
   set(BLAZE_BLAS_IS_PARALLEL 0 CACHE BOOL "Specify whether the used BLAS library is itself parallelized or not.")
   set(BLAZE_BLAS_USE_MATRIX_VECTOR_MULTIPLICATION 0 CACHE BOOL "Use BLAS kernels for dense matrix/vector multiplications instead of the default Blaze kernels.")
   set(BLAZE_BLAS_USE_MATRIX_MATRIX_MULTIPLICATION 1 CACHE BOOL "Use BLAS kernels for dense matrix multiplications instead of the default Blaze kernels.")
   set(BLAZE_BLAS_INCLUDE_FILE "<cblas.h>" CACHE STRING "Specify the name of the BLAS header file (e.g. with MKL the file is called mkl_cblas.h)")
else ()
   unset(BLAZE_BLAS_IS_64BIT CACHE)
   unset(BLAZE_BLAS_IS_PARALLEL CACHE)
   unset(BLAZE_BLAS_USE_MATRIX_VECTOR_MULTIPLICATION CACHE)
   unset(BLAZE_BLAS_USE_MATRIX_MATRIX_MULTIPLICATION CACHE)
   unset(BLAZE_BLAS_INCLUDE_FILE CACHE)
endif ()

if (BLAZE_BLAS_MODE)
   set(BLAZE_BLAS_MODE 1)
else ()
   set(BLAZE_BLAS_MODE 0)
endif ()

if (BLAZE_BLAS_IS_64BIT)
   set(BLAZE_BLAS_IS_64BIT 1)
else ()
   set(BLAZE_BLAS_IS_64BIT 0)
endif ()

if (BLAZE_BLAS_IS_PARALLEL)
   set(BLAZE_BLAS_IS_PARALLEL 1)
else ()
   set(BLAZE_BLAS_IS_PARALLEL 0)
endif ()

if (BLAZE_BLAS_USE_MATRIX_VECTOR_MULTIPLICATION)
   set(BLAZE_BLAS_USE_MATRIX_VECTOR_MULTIPLICATION 1)
else ()
   set(BLAZE_BLAS_USE_MATRIX_VECTOR_MULTIPLICATION 0)
endif ()

if (BLAZE_BLAS_USE_MATRIX_MATRIX_MULTIPLICATION)
   set(BLAZE_BLAS_USE_MATRIX_MATRIX_MULTIPLICATION 1)
else ()
   set(BLAZE_BLAS_USE_MATRIX_MATRIX_MULTIPLICATION 0)
endif ()

if (BLAZE_BLAS_INCLUDE_FILE)
   set(BLAZE_BLAS_INCLUDE_FILE ${BLAZE_BLAS_INCLUDE_FILE})
else ()
   set(BLAZE_BLAS_INCLUDE_FILE "<cblas.h>")
endif ()

configure_file ("${CMAKE_CURRENT_LIST_DIR}/cmake/BLAS.h.in"
                "${CMAKE_CURRENT_BINARY_DIR}/blaze/config/BLAS.h")


#==================================================================================================
# Configure transpose flag
#==================================================================================================

set(BLAZE_TRANSPOSE_FLAG "blaze::columnVector" CACHE STRING "Specify the default transpose flag for all vectors of the Blaze library.")
set_property(CACHE BLAZE_TRANSPOSE_FLAG PROPERTY STRINGS "blaze::columnVector;blaze::rowVector")

configure_file ("${CMAKE_CURRENT_LIST_DIR}/cmake/TransposeFlag.h.in"
                "${CMAKE_CURRENT_BINARY_DIR}/blaze/config/TransposeFlag.h")


#==================================================================================================
# Configure storage order
#==================================================================================================

set(BLAZE_STORAGE_ORDER "blaze::rowMajor" CACHE STRING "Specify the default storage order for all matrices of the Blaze library.")
set_property(CACHE BLAZE_STORAGE_ORDER PROPERTY STRINGS "blaze::rowMajor;blaze::columnMajor")

configure_file ("${CMAKE_CURRENT_LIST_DIR}/cmake/StorageOrder.h.in"
                "${CMAKE_CURRENT_BINARY_DIR}/blaze/config/StorageOrder.h")


#==================================================================================================
# Configure alignment
#==================================================================================================

set(BLAZE_ALIGNMENT "blaze::aligned" CACHE STRING "Specify the default alignment for all vectors and matrices of the Blaze library.")
set_property(CACHE BLAZE_ALIGNMENT PROPERTY STRINGS "blaze::aligned;blaze::unaligned")

configure_file ("${CMAKE_CURRENT_LIST_DIR}/cmake/Alignment.h.in"
                "${CMAKE_CURRENT_BINARY_DIR}/blaze/config/Alignment.h")


#==================================================================================================
# Configure padding
#==================================================================================================

set(BLAZE_PADDING "blaze::padded" CACHE STRING "Specify the default padding flag for all vectors and matrices of the Blaze library")
set_property(CACHE BLAZE_PADDING PROPERTY STRINGS "blaze::padded;blaze::unpadded")

configure_file ("${CMAKE_CURRENT_LIST_DIR}/cmake/Padding.h.in"
                "${CMAKE_CURRENT_BINARY_DIR}/blaze/config/Padding.h")


#==================================================================================================
# Configure vectorization

=== ext/src/bwa/CMakeLists.txt ===
############################################################################
# Copyright (c) 2016 Saint Petersburg State University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(bwa C)

find_package(Threads)
if (CMAKE_USE_PTHREADS_INIT)
  add_definitions(-DHAVE_PTHREAD)
endif()

include(CheckFunctionExists)
include(CheckLibraryExists)
check_function_exists(shm_open HAVE_SHM_OPEN)
if (NOT HAVE_SHM_OPEN)
  check_library_exists(rt shm_open "" HAVE_SHM_OPEN_IN_RT)
endif()
if (NOT HAVE_SHM_OPEN AND NOT HAVE_SHM_OPEN_IN_RT)
  message(FATAL_ERROR "Cannot find shm_open()")
endif()

add_library(bwa STATIC
  utils.c kthread.c ksw.c bwt.c bntseq.c bwa.c bwamem.c bwamem_pair.c
  bwamem_extra.c malloc_wrap.c is.c bwtindex.c rope.c rle.c kstring.c)

target_link_libraries(bwa zlibstatic m)
if (HAVE_SHM_OPEN_IN_RT)
  target_link_libraries(bwa rt)
endif()

add_executable(spades-bwa
               main.c
               fastmap.c pemerge.c maxk.c kopen.c bwtaln.c bwtgap.c bwaseqio.c
               bamlite.c bwtsw2_main.c bwashm.c bwtsw2_main.c bwtsw2_aux.c
               bwtsw2_core.c bwtsw2_chain.c bwt_lite.c bwape.c bwase.c bwtsw2_pair.c)
target_link_libraries(spades-bwa bwa)
if (SPADES_STATIC_BUILD)
  set_target_properties(spades-bwa PROPERTIES LINK_SEARCH_START_STATIC 1)
endif()

install(TARGETS spades-bwa
        RUNTIME DESTINATION bin)

=== ext/src/easel/CMakeLists.txt ===
project(easel C)

set(EASEL_MAIN_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(EASEL_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
set(EASEL_TOOLS_BINARY_DIR ${EASEL_BINARY_DIR}/bin)
set(EASEL_BUILT_INCLUDE_DIR ${EASEL_BINARY_DIR}/include)

set(EASEL_DATE "Aug 2023")
set(EASEL_COPYRIGHT "Copyright (C) 2023 Howard Hughes Medical Institute")
set(EASEL_LICENSE "Freely distributed under the BSD open source license.")
set(EASEL_VERSION 0.49)
set(EASEL_URL "http://bioeasel.org/")

include(CheckIncludeFiles)
check_include_files(endian.h HAVE_ENDIAN_H)
check_include_files(inttypes.h HAVE_INTTYPES_H)
check_include_files(stdint.h HAVE_STDINT_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(strings.h HAVE_STRINGS_H)
check_include_files(sys/types.h HAVE_SYS_TYPES_H)
check_include_files(sys/param.h HAVE_SYS_PARAM_H)
check_include_files(sys/sysctl.h HAVE_SYS_SYSCTL_H)
check_include_files(netinet/in.h HAVE_NETINET_IN_H)

include(CheckCSourceCompiles)
check_c_source_compiles("
#include <x86intrin.h>
#include <stdint.h>
int stub_sse(void) {
__m128i v1 = _mm_set1_epi32(42);
__m128i v2 = _mm_set1_epi32(86);
union { __m128i v; int32_t x[4]; } v3;
v3.v = _mm_add_epi32(v1, v2);
return (int) v3.x[0];
}
int main(void) { if (stub_sse() != 128) return 1; else return 0; }" eslENABLE_SSE)

check_c_source_compiles("
#include <x86intrin.h>
#include <stdint.h>
int stub_sse4(void) {
__m128i v1 = _mm_set1_epi8(-42);
__m128i v2 = _mm_set1_epi8(-86);
union { __m128i v; int8_t x[16]; } v3;
v3.v = _mm_adds_epi8(v1, v2);
v2   = _mm_max_epi8(v1, v1);
return (int) -v3.x[0];
}
int main(void) { if (stub_sse4() != 128) return 1; else return 0; }" eslENABLE_SSE4)

check_c_source_compiles("
#include <x86intrin.h>
#include <stdio.h>
#include <stdint.h>
int main(void) {
  __m256i v1 = _mm256_set1_epi32(42);
  __m256i v2 = _mm256_set1_epi32(214);
  union { __m256i v; int32_t x[8]; } v3;
  v3.v = _mm256_add_epi32(v1, v2);
  printf(\"%d\n\", v3.x[2]);}" eslENABLE_AVX)

check_c_source_compiles("
#include <x86intrin.h>
#include <stdint.h>
int main(void) {
  __m512i v1 = _mm512_set1_epi8(21);
  union { __m256i v; int8_t x[32]; } v2;
  v2.v = _mm512_extracti32x8_epi32(_mm512_adds_epi8(v1, v1), 0x1);
  return (v2.x[0] == 42 ? 0 : 1);}" eslENABLE_AVX512)

check_c_source_compiles("
#include <stdint.h>
#include <arm_neon.h>
int stub_neon(void) {
  int32x4_t v1 = vdupq_n_s32(42);
  int32x4_t v2 = vdupq_n_s32(86);
  union { int32x4_t v; int32_t x[4]; } v3;
  v3.v = vaddq_s32(v1, v2);
  return (int) v3.x[0];
}
int main(void) { if (stub_neon() != 128) return 1; else return 0; }" eslENABLE_NEON)

check_c_source_compiles("
#include <stdint.h>
#include <arm_neon.h>
int main(void) {
  int16x8_t   a1 = { 1, 2, 8, 3, 4, 5, 6, 7 };
  int16_t     r1 = vmaxvq_s16(a1); // = 8 : horizontal max
  uint8x16_t  a2 = { 1, 2, 16, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 };
  uint8_t     r2 = vmaxvq_u8(a2);  // = 16 : horizontal max
  float32x4_t a3 = { 1.0, 2.0, 3.0, 4.0 };
  float       r3 = vaddvq_f32(a3); // = 10.0 : horizontal sum
  return 0;
}" eslHAVE_NEON_AARCH64)

check_c_source_compiles("
#include <pmmintrin.h>
int main(void) {
  _MM_SET_FLUSH_ZERO_MODE (_MM_FLUSH_ZERO_ON);
  return 0;
}" HAVE_FLUSH_ZERO_MODE)
  
check_c_source_compiles("
#include <xmmintrin.h>
int main(void) {
  _MM_SET_DENORMALS_ZERO_MODE (_MM_DENORMALS_ZERO_ON);
  return 0;
}" HAVE_DENORMALS_ZERO_MODE)

include(CheckFunctionExists)
check_function_exists(aligned_alloc HAVE_ALIGNED_ALLOC)
check_function_exists(erfc HAVE_ERFC)
check_function_exists(getpid HAVE_GETPID)
check_function_exists(_mm_malloc HAVE__MM_MALLOC)
check_function_exists(popen HAVE_POPEN)
check_function_exists(posix_memalign HAVE_POSIX_MEMALIGN)
check_function_exists(strcasecmp HAVE_STRCASECMP)
check_function_exists(strsep HAVE_STRSEP)
check_function_exists(sysconf HAVE_SYSCONF)
check_function_exists(sysctl HAVE_SYSCTL)
check_function_exists(times HAVE_TIMES)
check_function_exists(fseeko HAVE_FSEEKO)

find_package(Threads)
if (CMAKE_USE_PTHREADS_INIT)
  set(HAVE_PTHREAD 1)
endif()

set(eslLIBRARY 1)
set(HAVE_FUNC_ATTRIBUTE_NORETURN 1)
set(HAVE_FUNC_ATTRIBUTE_FORMAT 1)

configure_file("${EASEL_MAIN_SRC_DIR}/esl_config.h.cmake"
               "${EASEL_BUILT_INCLUDE_DIR}/esl_config.h")

set(easel_src
  easel.c
  esl_alloc.c esl_alphabet.c esl_arr2.c esl_arr3.c esl_bitfield.c
  esl_buffer.c esl_cluster.c esl_composition.c esl_cpu.c esl_dirichlet.c
  esl_distance.c esl_dmatrix.c esl_dsqdata.c esl_exponential.c esl_fileparser.c
  esl_gamma.c esl_gencode.c esl_getopts.c esl_gev.c esl_graph.c esl_gumbel.c
  esl_heap.c esl_histogram.c esl_hmm.c esl_huffman.c esl_hyperexp.c
  esl_iset.c esl_json.c esl_keyhash.c esl_lognormal.c esl_matrixops.c
  esl_mem.c esl_minimizer.c esl_mixdchlet.c esl_mixgev.c esl_mpi.c
  esl_msa.c esl_msacluster.c esl_msafile.c esl_msafile2.c esl_msafile_a2m.c
  esl_msafile_afa.c esl_msafile_clustal.c esl_msafile_phylip.c esl_msafile_psiblast.c
  esl_msafile_selex.c esl_msafile_stockholm.c esl_msashuffle.c esl_msaweight.c
  esl_normal.c esl_paml.c esl_quicksort.c esl_random.c esl_rand64.c esl_randomseq.c
  esl_ratematrix.c esl_recorder.c esl_red_black.c esl_regexp.c esl_rootfinder.c
  esl_scorematrix.c esl_sq.c esl_sqio.c esl_sqio_ascii.c esl_sqio_ncbi.c
  esl_ssi.c esl_stack.c esl_stats.c esl_stopwatch.c esl_stretchexp.c
  esl_subcmd.c esl_threads.c esl_tree.c esl_varint.c esl_vectorops.c esl_weibull.c
  esl_workqueue.c esl_wuss.c
  esl_sse.c esl_avx.c esl_avx512.c esl_neon.c
)
    
add_library(easel STATIC ${easel_src})
target_link_libraries(easel m)
target_include_directories(easel SYSTEM PUBLIC ${EASEL_BUILT_INCLUDE_DIR} ${EASEL_MAIN_SRC_DIR})

=== ext/src/hmmer/CMakeLists.txt ===
project(hmmer C)

set(HMMER_DATE "Aug 2023")
set(HMMER_COPYRIGHT "Copyright (C) 2020 Howard Hughes Medical Institute.")
set(HMMER_LICENSE "Freely distributed under the BSD open source license.")
set(HMMER_VERSION "3.4")
set(HMMER_URL "http://hmmer.org/")
set(HMMER_SADIR "libdivsufsort")

set(HMMER_MAIN_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)
set(HMMER_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
set(HMMER_TOOLS_BINARY_DIR ${HMMER_BINARY_DIR}/bin)
set(HMMER_BUILT_INCLUDE_DIR ${HMMER_BINARY_DIR}/include)

include(CheckIncludeFiles)

check_include_files(endian.h HAVE_ENDIAN_H)
check_include_files(inttypes.h HAVE_INTTYPES_H)
check_include_files(stdint.h HAVE_STDINT_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(strings.h HAVE_STRINGS_H)
check_include_files(netinet/in.h HAVE_NETINET_IN_H)
check_include_files(sys/types.h HAVE_SYS_TYPES_H)
check_include_files(sys/param.h HAVE_SYS_PARAM_H)
check_include_files(sys/sysctl.h HAVE_SYS_SYSCTL_H)

find_package(Threads)
if (CMAKE_USE_PTHREADS_INIT)
  set(HAVE_PTHREAD 1)
  set(HMMER_THREADS 1)
endif()

set(eslLIBRARY 1)

include(CheckFunctionExists)
check_function_exists(fstat HAVE_FSTAT)
check_function_exists(getcwd HAVE_GETCWD)
check_function_exists(getpid HAVE_GETPID)
check_function_exists(mkstemp HAVE_MKSTEMP)
check_function_exists(popen HAVE_POPEN)
check_function_exists(stat HAVE_STAT)
check_function_exists(strcasecmp HAVE_STRCASECMP)
check_function_exists(sysconf HAVE_SYSCONF)
check_function_exists(sysctl HAVE_SYSCTL)
check_function_exists(times HAVE_TIMES)

configure_file("${HMMER_MAIN_SRC_DIR}/p7_config.h.cmake"
               "${HMMER_BUILT_INCLUDE_DIR}/p7_config.h")

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(hmmer_src
  src/build.c src/cachedb.c src/emit.c src/errors.c src/evalues.c src/eweight.c
  src/generic_decoding.c src/generic_fwdback.c src/generic_fwdback_chk.c
  src/generic_fwdback_banded.c src/generic_null2.c src/generic_msv.c
  src/generic_optacc.c src/generic_stotrace.c src/generic_viterbi.c
  src/generic_vtrace.c src/h2_io.c src/heatmap.c src/hmmlogo.c src/hmmdmstr.c
  src/hmmdwrkr.c src/hmmdutils.c src/hmmer.c src/logsum.c src/modelconfig.c
  src/modelstats.c src/mpisupport.c src/seqmodel.c src/tracealign.c
  src/p7_alidisplay.c src/p7_bg.c src/p7_builder.c src/p7_domaindef.c
  src/p7_gbands.c src/p7_gmx.c src/p7_gmxb.c src/p7_gmxchk.c
  src/p7_hmm.c src/p7_hmmcache.c src/p7_hmmfile.c src/p7_hmmwindow.c
  src/p7_null3.c src/p7_pipeline.c src/p7_prior.c src/p7_profile.c
  src/p7_spensemble.c src/p7_tophits.c src/p7_trace.c src/p7_scoredata.c
  src/p7_hit.c src/p7_domain.c
  src/hmmpgmd2msa.c src/fm_alphabet.c src/fm_general.c src/fm_sse.c src/fm_ssv.c)

if (eslENABLE_SSE)
  set(hmmer_sse_src
    src/impl_sse/decoding.c src/impl_sse/fwdback.c src/impl_sse/io.c src/impl_sse/ssvfilter.c
    src/impl_sse/msvfilter.c src/impl_sse/null2.c src/impl_sse/optacc.c src/impl_sse/stotrace.c
    src/impl_sse/vitfilter.c src/impl_sse/p7_omx.c src/impl_sse/p7_oprofile.c src/impl_sse/mpi.c)
  set(hmmer_src ${hmmer_src} ${hmmer_sse_src})
endif()

if (eslENABLE_NEON)
  set(hmmer_neon_src
    src/impl_neon/decoding.c src/impl_neon/io.c src/impl_neon/msvfilter.c src/impl_neon/optacc.c
    src/impl_neon/p7_oprofile.c src/impl_neon/stotrace.c
    src/impl_neon/fwdback.c src/impl_neon/mpi.c src/impl_neon/null2.c src/impl_neon/p7_omx.c
    src/impl_neon/ssvfilter.c src/impl_neon/vitfilter.c)
  set(hmmer_src ${hmmer_src} ${hmmer_neon_src})
endif()

add_library(hmmer STATIC ${hmmer_src})
target_include_directories(hmmer SYSTEM PUBLIC ${HMMER_BUILT_INCLUDE_DIR} ${HMMER_MAIN_SRC_DIR})
target_link_libraries(hmmer easel m)

message("${easel_includes}")

=== ext/src/lexy/CMakeLists.txt ===
# Copyright (C) 2020-2024 Jonathan Müller and lexy contributors
# SPDX-License-Identifier: BSL-1.0

cmake_minimum_required(VERSION 3.8)
project(lexy VERSION 2022.12.1 LANGUAGES CXX)

set(LEXY_USER_CONFIG_HEADER "" CACHE FILEPATH "The user config header for lexy.")
option(LEXY_FORCE_CPP17     "Whether or not lexy should use C++17 even if compiler supports C++20." OFF)

add_subdirectory(src)

if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    cmake_minimum_required(VERSION 3.18)
    option(LEXY_BUILD_BENCHMARKS "whether or not benchmarks should be built" OFF)
    option(LEXY_BUILD_EXAMPLES   "whether or not examples should be built" ON)
    option(LEXY_BUILD_TESTS      "whether or not tests should be built" ON)
    option(LEXY_BUILD_DOCS       "whether or not docs should be built" OFF)
    option(LEXY_BUILD_PACKAGE    "whether or not the package should be built" ON)
    option(LEXY_ENABLE_INSTALL   "whether or not to enable the install rule" ON)

    if(LEXY_BUILD_PACKAGE)
        set(package_files include/ src/ cmake/ CMakeLists.txt LICENSE)
        add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/lexy-src.zip
            COMMAND ${CMAKE_COMMAND} -E tar c ${CMAKE_CURRENT_BINARY_DIR}/lexy-src.zip --format=zip -- ${package_files}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
            DEPENDS ${package_files})
        add_custom_target(lexy_package DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/lexy-src.zip)
    endif()

    if(LEXY_BUILD_EXAMPLES)
        add_subdirectory(examples)
    endif()
    if(LEXY_BUILD_BENCHMARKS)
        add_subdirectory(benchmarks)
    endif()
    if(LEXY_BUILD_TESTS)
        set(DOCTEST_NO_INSTALL ON)
        enable_testing()
        add_subdirectory(tests)
    endif()
    if(LEXY_BUILD_DOCS)
        add_subdirectory(docs EXCLUDE_FROM_ALL)
    endif()

    if(LEXY_ENABLE_INSTALL)
        include(CMakePackageConfigHelpers)
        include(GNUInstallDirs)

        install(TARGETS lexy lexy_core lexy_file lexy_unicode lexy_ext _lexy_base lexy_dev
            EXPORT ${PROJECT_NAME}Targets
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

        install(EXPORT ${PROJECT_NAME}Targets
            NAMESPACE foonathan::
            DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")

        configure_package_config_file(
            cmake/lexyConfig.cmake.in
            "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
            INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")
        install(FILES "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
            DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")

        # YYYY.MM.N1 is compatible with YYYY.MM.N2.
        write_basic_package_version_file(
            "${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
            COMPATIBILITY SameMinorVersion)

        install(FILES "${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
            DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")

        install(DIRECTORY include/lexy include/lexy_ext
            DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
            FILES_MATCHING
            PATTERN "*.hpp")
    endif()
endif()

=== ext/src/samtools/CMakeLists.txt ===
# -*- cmake -*-

############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(samtools C)

add_definitions(-D_FILE_OFFSET_BITS=64 -D_USE_KNETFILE -DMD5SUM_MAIN -D_CURSES_LIB=1)

add_library (samtools
  kstring.c
  bam_aux.c
  bam.c
  bam_import.c
  sam.c
  bam_index.c
  bam_pileup.c
  bam_lpileup.c
  bam_md.c
  razf.c
  faidx.c
  bedidx.c
  bam_sort.c
  sam_header.c
  bam_reheader.c
  kprobaln.c
  bam_cat.c)
target_link_libraries(samtools BamTools zlibstatic)

=== ext/src/zlib-ng/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)
if(CMAKE_VERSION VERSION_LESS 3.12)
    cmake_policy(VERSION ${CMAKE_VERSION})
else()
    cmake_policy(VERSION 3.5.1...3.13.2)
endif()
message(STATUS "Using CMake version ${CMAKE_VERSION}")

# If not specified on the command line, enable C11 as the default
# Configuration items that affect the global compiler environment standards
# should be issued before the "project" command.
if(NOT CMAKE_C_STANDARD)
    set(CMAKE_C_STANDARD 11)          # The C standard whose features are requested to build this target
endif()
if(NOT CMAKE_C_STANDARD_REQUIRED)
    set(CMAKE_C_STANDARD_REQUIRED ON) # Boolean describing whether the value of C_STANDARD is a requirement
endif()
if(NOT CMAKE_C_EXTENSIONS)
    set(CMAKE_C_EXTENSIONS OFF)       # Boolean specifying whether compiler specific extensions are requested
endif()
set(VALID_C_STANDARDS "99" "11")
if(NOT CMAKE_C_STANDARD IN_LIST VALID_C_STANDARDS)
    MESSAGE(FATAL_ERROR "CMAKE_C_STANDARD:STRING=${CMAKE_C_STANDARD} not in known standards list\n ${VALID_C_STANDARDS}")
endif()

# Parse the full version number from zlib.h and include in ZLIB_FULL_VERSION
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/zlib${SUFFIX}.h.in _zlib_h_contents)
string(REGEX REPLACE ".*#define[ \t]+ZLIB_VERSION[ \t]+\"([0-9]+.[0-9]+.[0-9]+).*\".*"
        "\\1" ZLIB_HEADER_VERSION ${_zlib_h_contents})
string(REGEX REPLACE ".*#define[ \t]+ZLIBNG_VERSION[ \t]+\"([-0-9A-Za-z.]+)\".*"
        "\\1" ZLIBNG_HEADER_VERSION ${_zlib_h_contents})
message(STATUS "ZLIB_HEADER_VERSION: ${ZLIB_HEADER_VERSION}")
message(STATUS "ZLIBNG_HEADER_VERSION: ${ZLIBNG_HEADER_VERSION}")

project(zlib VERSION ${ZLIB_HEADER_VERSION} LANGUAGES C)

include(CheckTypeSize)
include(CheckSymbolExists)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CheckCCompilerFlag)
include(CMakeDependentOption)
include(FeatureSummary)

include(cmake/detect-arch.cmake)
include(cmake/detect-install-dirs.cmake)
include(cmake/detect-coverage.cmake)
include(cmake/detect-intrinsics.cmake)
include(cmake/detect-sanitizer.cmake)
include(cmake/fallback-macros.cmake)

if(CMAKE_TOOLCHAIN_FILE)
    message(STATUS "Using CMake toolchain: ${CMAKE_TOOLCHAIN_FILE}")
endif()

# Make sure we use an appropriate BUILD_TYPE by default, "Release" to be exact
# this should select the maximum generic optimisation on the current platform (i.e. -O3 for gcc/clang)
get_property(GENERATOR_IS_MULTI_CONFIG GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(NOT GENERATOR_IS_MULTI_CONFIG)
    if(NOT CMAKE_BUILD_TYPE)
        set(CMAKE_BUILD_TYPE "Release" CACHE STRING
            "Choose the type of build, standard options are: Debug Release RelWithDebInfo MinSizeRel."
            FORCE)
        add_feature_info(CMAKE_BUILD_TYPE 1 "Build type: ${CMAKE_BUILD_TYPE} (default)")
    else()
        add_feature_info(CMAKE_BUILD_TYPE 1 "Build type: ${CMAKE_BUILD_TYPE} (selected)")
    endif()
endif()

#
# Options parsing
#
option(WITH_GZFILEOP "Compile with support for gzFile related functions" ON)
option(ZLIB_COMPAT "Compile with zlib compatible API" OFF)
option(ZLIB_ENABLE_TESTS "Build test binaries" ON)
option(ZLIBNG_ENABLE_TESTS "Test zlib-ng specific API" ON)
option(WITH_GTEST "Build gtest_zlib" ON)
option(WITH_FUZZERS "Build test/fuzz" OFF)
option(WITH_BENCHMARKS "Build test/benchmarks" OFF)
option(WITH_BENCHMARK_APPS "Build application benchmarks" OFF)
option(WITH_OPTIM "Build with optimisation" ON)
option(WITH_REDUCED_MEM "Reduced memory usage for special cases (reduces performance)" OFF)
option(WITH_NEW_STRATEGIES "Use new strategies" ON)
option(WITH_NATIVE_INSTRUCTIONS
    "Instruct the compiler to use the full instruction set on this host (gcc/clang -march=native)" OFF)
option(WITH_MAINTAINER_WARNINGS "Build with project maintainer warnings" OFF)
option(WITH_CODE_COVERAGE "Enable code coverage reporting" OFF)
option(WITH_INFLATE_STRICT "Build with strict inflate distance checking" OFF)
option(WITH_INFLATE_ALLOW_INVALID_DIST "Build with zero fill for inflate invalid distances" OFF)
option(WITH_UNALIGNED "Support unaligned reads on platforms that support it" ON)

set(ZLIB_SYMBOL_PREFIX "" CACHE STRING "Give this prefix to all publicly exported symbols.
Useful when embedding into a larger library.
Default is no prefix (empty prefix).")

# Add multi-choice option
set(WITH_SANITIZER AUTO CACHE STRING "Enable sanitizer support")
set_property(CACHE WITH_SANITIZER PROPERTY STRINGS "Memory" "Address" "Undefined" "Thread")

if(BASEARCH_ARM_FOUND)
    option(WITH_ACLE "Build with ACLE" ON)
    option(WITH_NEON "Build with NEON intrinsics" ON)
    option(WITH_ARMV6 "Build with ARMv6 SIMD" ON)
elseif(BASEARCH_PPC_FOUND)
    option(WITH_ALTIVEC "Build with AltiVec (VMX) optimisations for PowerPC" ON)
    option(WITH_POWER8 "Build with optimisations for POWER8" ON)
    option(WITH_POWER9 "Build with optimisations for POWER9" ON)
elseif(BASEARCH_RISCV_FOUND)
    option(WITH_RVV "Build with RVV intrinsics" ON)
elseif(BASEARCH_S360_FOUND)
    option(WITH_DFLTCC_DEFLATE "Build with DFLTCC intrinsics for compression on IBM Z" OFF)
    option(WITH_DFLTCC_INFLATE "Build with DFLTCC intrinsics for decompression on IBM Z" OFF)
    option(WITH_CRC32_VX "Build with vectorized CRC32 on IBM Z" ON)
elseif(BASEARCH_X86_FOUND)
    option(WITH_AVX2 "Build with AVX2" ON)
    option(WITH_AVX512 "Build with AVX512" ON)
    option(WITH_AVX512VNNI "Build with AVX512 VNNI extensions" ON)
    option(WITH_SSE2 "Build with SSE2" ON)
    option(WITH_SSSE3 "Build with SSSE3" ON)
    option(WITH_SSE42 "Build with SSE42" ON)
    option(WITH_PCLMULQDQ "Build with PCLMULQDQ" ON)
    option(WITH_VPCLMULQDQ "Build with VPCLMULQDQ" ON)
endif()

option(INSTALL_UTILS "Copy minigzip and minideflate during install" OFF)

mark_as_advanced(FORCE
    ZLIB_SYMBOL_PREFIX
    WITH_REDUCED_MEM
    WITH_ACLE WITH_NEON
    WITH_ARMV6
    WITH_DFLTCC_DEFLATE
    WITH_DFLTCC_INFLATE
    WITH_CRC32_VX
    WITH_AVX2 WITH_SSE2
    WITH_SSSE3 WITH_SSE42
    WITH_PCLMULQDQ
    WITH_ALTIVEC
    WITH_POWER8
    WITH_POWER9
    WITH_RVV
    WITH_INFLATE_STRICT
    WITH_INFLATE_ALLOW_INVALID_DIST
    WITH_UNALIGNED
    INSTALL_UTILS
    )

if(ZLIB_COMPAT)
    add_definitions(-DZLIB_COMPAT)
    set(WITH_GZFILEOP ON)
    set(SUFFIX "")
    set(ZLIB_FULL_VERSION ${ZLIB_HEADER_VERSION}.zlib-ng)
else()
    set(SUFFIX "-ng")
    set(ZLIB_FULL_VERSION ${ZLIBNG_HEADER_VERSION})
endif()

if(WITH_GZFILEOP)
    add_definitions(-DWITH_GZFILEOP)
endif()

if(CMAKE_C_COMPILER_ID MATCHES "^Intel")
    if(CMAKE_HOST_UNIX)
        set(WARNFLAGS -Wall)
        set(WARNFLAGS_MAINTAINER -Wall -Wcheck -Wremarks)
        set(WARNFLAGS_DISABLE)
    else()
        set(WARNFLAGS /Wall)
        set(WARNFLAGS_MAINTAINER /W5)
        set(WARNFLAGS_DISABLE)
    endif()
elseif(MSVC)
    # Minimum supported MSVC version is 1800 = Visual Studio 12.0/2013
    # See also https://cmake.org/cmake/help/latest/variable/MSVC_VERSION.html
    if(MSVC_VERSION VERSION_LESS 1800)
        message(SEND_ERROR "Unsupported Visual Studio compiler version (requires 2013 or later).")
    endif()
    # TODO. ICC can be used through MSVC. I'm not sure if we'd ever see that combination
    # (who'd use cmake from an IDE...) but checking for ICC before checking for MSVC should
    # avoid mistakes.
    # /Oi ?
    set(WARNFLAGS /W3)
    set(WARNFLAGS_MAINTAINER /W4)
    set(WARNFLAGS_DISABLE)
    if(BASEARCH_ARM_FOUND)
        add_definitions(-D_ARM_WINAPI_PARTITION_DESKTOP_SDK_AVAILABLE)
        if(NOT "${ARCH}" MATCHES "aarch64")
            set(NEONFLAG "/arch:VFPv4")
        endif()
    endif()
elseif(CMAKE_C_COMPILER_ID MATCHES "GNU" OR CMAKE_C_COMPILER_ID MATCHES "Clang")
    # Enable warnings in GCC and Clang
    set(WARNFLAGS -Wall)
    set(WARNFLAGS_MAINTAINER -Wextra)
    set(WARNFLAGS_DISABLE)
    if(NOT WITH_NATIVE_INSTRUCTIONS)
        if(BASEARCH_ARM_FOUND)
            if("${ARCH}" MATCHES "arm" AND NOT CMAKE_C_FLAGS MATCHES "-mfloat-abi")
                # Auto-detect support for ARM floating point ABI
                check_include_file(features.h HAVE_FEATURES_H)
                if(HAVE_FEATURES_H)
                    set(CMAKE_REQUIRED_FLAGS -mfloat-abi=softfp)
                    check_c_source_compiles(
                        "#include <features.h>
                        int main() { return 0; }"
                        HAVE_FLOATABI_SOFTFP)
                    if(HAVE_FLOATABI_SOFTFP)
                        set(FLOATABI -mfloat-abi=softfp)
                    else()
                        set(CMAKE_REQUIRED_FLAGS -mfloat-abi=hard)
                        check_c_source_compiles(
                            "#include <features.h>
                            int main() { return 0; }"
                            HAVE_FLOATABI_HARD)
                        if(HAVE_FLOATABI_HARD)
                            set(FLOATABI -mfloat-abi=hard)
                        endif()
                    endif()
                    set(CMAKE_REQUIRED_FLAGS)
                endif()
                if(FLOATABI)
                    message(STATUS "ARM floating point arch: ${FLOATABI}")
                    add_compile_options(${FLOATABI})
                else()
                    message(STATUS "ARM floating point arch not auto-detected")
                endif()
            endif()
        endif()
        # Check whether -fno-lto is available
        set(CMAKE_REQUIRED_FLAGS "-fno-lto")
        check_c_source_compiles(
            "int main() { return 0; }"
            FNO_LTO_AVAILABLE FAIL_REGEX "not supported")
        set(CMAKE_REQUIRED_FLAGS)
        if(FNO_LTO_AVAILABLE)
            set(NOLTOFLAG "-fno-lto")
        endif()
    endif()
    if(MINGW)
        # Add `-Wno-pedantic-ms-format` only if the toolchain supports it
        check_c_compiler_flag(-Wno-pedantic-ms-format HAVE_NO_PEDANTIC_MS_FORMAT)
        if(HAVE_NO_PEDANTIC_MS_FORMAT)
            list(APPEND WARNFLAGS_DISABLE -Wno-pedantic-ms-format)
        endif()
    endif()
endif()

# Set native march/mcpu
if(WITH_NATIVE_INSTRUCTIONS)
    if(CMAKE_C_COMPILER_ID MATCHES "GNU" OR CMAKE_C_COMPILER_ID MATCHES "Clang")
        if(BASEARCH_PPC_FOUND)
            set(NATIVEFLAG "-mcpu=native")
        else()
            set(NATIVEFLAG "-march=native")
        endif()
        # Apply flag to all source files and compilation checks
        add_compile_options(${NATIVEFLAG})
    else()
        message(STATUS "Ignoring WITH_NATIVE_INSTRUCTIONS; not implemented yet on this configuration")
        set(WITH_NATIVE_INSTRUCTIONS OFF)
    endif()
endif()

# Force disable LTO if WITH_NATIVE_INSTRUCTIONS is not active
if(NOT WITH_NATIVE_INSTRUCTIONS)
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION OFF)
    foreach(_cfg_name IN LISTS CMAKE_CONFIGURATION_TYPES)
        string(TOUPPER "${_cfg_name}" _cfg_name_uc)
        set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_${_cfg_name_uc} OFF)
    endforeach()
endif()

# Set architecture alignment requirements
if(NOT WITH_UNALIGNED)
    add_definitions(-DNO_UNALIGNED)
    message(STATUS "Unaligned reads manually disabled")
endif()

# Apply warning compiler flags
if(WITH_MAINTAINER_WARNINGS)
    add_compile_options(${WARNFLAGS} ${WARNFLAGS_MAINTAINER} ${WARNFLAGS_DISABLE})
else()
    add_compile_options(${WARNFLAGS} ${WARNFLAGS_DISABLE})
endif()

# Set code coverage compiler flags
if(WITH_CODE_COVERAGE)
    add_code_coverage()
endif()

# Replace optimization level 3 added by default with level 2
if(NOT WITH_CODE_COVERAGE AND NOT MSVC AND NOT CMAKE_C_FLAGS MATCHES "([\\/\\-]O)3")
    string(REGEX REPLACE "([\\/\\-]O)3" "\\12"
        CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
endif()

#
# Check for standard/system includes
#
check_include_file(arm_acle.h  HAVE_ARM_ACLE_H)
if(HAVE_ARM_ACLE_H)
    add_definitions(-DHAVE_ARM_ACLE_H)
endif()
check_include_file(sys/auxv.h  HAVE_SYS_AUXV_H)
if(HAVE_SYS_AUXV_H)
    add_definitions(-DHAVE_SYS_AUXV_H)
endif()

=== debian/changelog ===
spades (4.0.0+dfsg1-1) experimental; urgency=medium

  * Team upload
  * New upstream version 4.0.0+dfsg1
  * Refreshing patches
  * Raising Standards version to 4.7.0 (no change)
  * Rewriting d/copyright
  * Changing the paths of the files to remove when repacking
  * Updating the list of files to exclude when repacking
  * Updating files related to shipped doc in the debian/ directory
  * Removing the now useless override of dh_installchangelogs
  * Using bamtools, googletest, spoa, boost, cuckoo, joblib and xxhash from the
    Debian packages instead of embedded copies, updating d/control accordingly
  * Updating paths in d/rules
  * Adding missing files to the CMakeLists.txt file of the samtools part
  * Deactivating build-time tests of which test data have vanished from the
    source package
  * Updating homepage URI
  * Removing obsolete Lintian override for source-is-missing
  * Adding a Lintian override for the embedded (modified) copy of Zlib

 -- Pierre Gruet <pgt@debian.org>  Wed, 02 Oct 2024 08:56:41 +0200

=== debian/control ===
Source: spades
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Sascha Steinbiss <satta@debian.org>,
           Michael R. Crusoe <crusoe@debian.org>,
           Alexandre Mestiashvili <mestia@debian.org>,
           Étienne Mollier <emollier@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3,
               asciidoctor,
               clang-format,
               clang-tidy,
               clang-tools,
               cmake,
               libbam-dev,
               libbamtools-dev,
               libbz2-dev,
               libboost-thread-dev,
               libc++-dev,
               libcuckoo-dev,
               libgtest-dev,
               libhts-dev,
               libnlopt-dev,
               libnlopt-cxx-dev,
               libparallel-hashmap-dev,
               libspoa-dev,
               libssw-dev,
               libxxhash-dev,
               libzstd-dev,
               llvm-dev,
               lynx,
               python3-all,
               python3-joblib,
               python3-yaml,
               zlib1g-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/med-team/spades
Vcs-Git: https://salsa.debian.org/med-team/spades.git
Homepage: https://github.com/ablab/spades
Rules-Requires-Root: no

Package: spades
Architecture: amd64
Depends: ${shlibs:Depends},
         ${python3:Depends},
         ${misc:Depends},
         python3,
         python3-joblib,
         python3-packaging,
         python3-yaml,
         bwa,
         bamtools,
         samtools
Description: genome assembler for single-cell and isolates data sets
 The SPAdes – St. Petersburg genome assembler is intended for both
 standard isolates and single-cell MDA bacteria assemblies.  It works
 with Illumina or IonTorrent reads and is capable of providing hybrid
 assemblies using PacBio and Sanger reads. You can also provide
 additional contigs that will be used as long reads.
 .
 This package provides the following additional pipelines:
  * metaSPAdes – a pipeline for metagenomic data sets
  * plasmidSPAdes – a pipeline for extracting and assembling plasmids
    from WGS data sets
  * metaplasmidSPAdes – a pipeline for extracting and assembling
    plasmids from metagenomic data sets
  * rnaSPAdes – a de novo transcriptome assembler from RNA-Seq data
  * truSPAdes – a module for TruSeq barcode assembly
  * biosyntheticSPAdes – a module for biosynthetic gene cluster
    assembly with paired-end reads
 .
 SPAdes provides several stand-alone binaries with relatively simple
 command-line interface: k-mer counting (spades-kmercounter), assembly
 graph construction (spades-gbuilder) and long read to graph aligner
 (spades-gmapper).

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

include /usr/share/dpkg/default.mk

mandir     := $(CURDIR)/debian/man
debfolder  := $(CURDIR)/debian

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export LC_ALL = C

%:
	dh $@ --sourcedirectory=src --buildsystem=cmake

override_dh_clean:
	dh_clean -X.orig

override_dh_auto_clean:
	dh_auto_clean
	find . -name "*.pyc" -delete
	rm -rf $(debfolder)/man_src/*.html $(debfolder)/man_src/*.?
	rm -rf $(mandir)

override_dh_auto_configure:
	dh_auto_configure -- -DBoost_NO_BOOST_CMAKE=TRUE -DSPADES_BOOST_ROOT:PATH="/usr"

override_dh_auto_build:
	dh_auto_build -- all debruijn_test include_test

execute_after_dh_auto_install:
	# Use Debian-packaged yaml module
	find debian/spades \
		-type f \
		-exec sed -i 's/pyyaml[2|3]/yaml/' {} +

	mkdir -p debian/$(DEB_SOURCE)/usr/libexec/spades/
	mv debian/$(DEB_SOURCE)/usr/bin/* debian/$(DEB_SOURCE)/usr/libexec/spades/

	rm -f debian/$(DEB_SOURCE)/usr/share/spades/*.html
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/manual.md
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/GPLv2.txt
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/README.md
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/LICENSE

override_dh_installman:
	mkdir -p $(mandir)
	asciidoctor -a docdate='' -b manpage $(debfolder)/man_src/*.adoc
	cp $(debfolder)/man_src/*.? $(mandir)
	dh_installman
